<template>
  <div>
    <v-btn
      small
      color="success"
      @click.stop="dialog = true"
    >
      Create new Update
    </v-btn>

    <v-dialog
      v-model="dialog"
      max-width="450"
    >
      <v-card>
        <v-card-title class="headline">Create a new Update</v-card-title>
        <v-form class="px-3" ref="form">
        <v-card-text>
          <v-text-field class="mb-5" label="Title" v-model="title" prepend-icon="folder" :rules="inputRules"></v-text-field>
          <v-text-field class="mb-5" label="Person in charge" v-model="person" prepend-icon="hourglass_empty" :rules="inputRules"></v-text-field>
            <v-menu offset-y>
                <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                    :value="dateFormatted"
                    :rules="inputRules"
                    label="Due by date"
                    prepend-icon="event"
                    v-bind="attrs"
                    v-on="on"
                    ></v-text-field>
                </template>
                <v-date-picker v-model="date" no-title></v-date-picker>
            </v-menu>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn text class="success" @click="submit" :loading="loading">Add Update</v-btn>
        </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>
  </div>
</template>
<script>
import db from '@/fb'

export default {
    data() {
        return {
            dialog: false,
            title:'',
            person:'',
            date: null,
            inputRules: [
                //Ignore the message if true
                v => v.length >= 3 || 'Minimum length is 3 characters'
            ],
            loading: false
        }
    },
    computed: {
      dateFormatted () {
        return this.date ? this.date : ''
      },
    },
    methods: {
        submit(){
            if(this.$refs.form.validate()){
                this.loading = true;
                const update = {
                  title: this.title,
                  person: this.person,
                  due: this.date,
                  status: 'Conception'
                }

                db.collection('updates').add(update).then(() => {
                  console.log('update added to db');
                  this.loading = false;
                  this.$emit('updateAdded');
                  this.refreshForm();
                })
            }
        },
        refreshForm(){
          this.dialog = false;
          this.$refs.form.reset();
        }
    }
}
</script>